Index: /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-themes/js/theme.js
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-themes/js/theme.js	(revision 12032)
+++ /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-themes/js/theme.js	(revision 12033)
@@ -999,4 +999,5 @@
 			'click .previous-theme': 'previousTheme',
 			'click .next-theme': 'nextTheme',
+			'click .wp-full-overlay-footer .devices button': 'devicePreview',
 			'keyup': 'keyEvent'
 		},
@@ -1017,4 +1018,8 @@
 				$( '.close-full-overlay' ).focus();
 			});
+
+			if ( themes.activeDevicePreview ) {
+				this.setDevicePreview( themes.activeDevicePreview );
+			}
 		},
 
@@ -1044,4 +1049,25 @@
 				this.$el.toggleClass( 'expanded' );
 			}
+
+			return false;
+		},
+
+		devicePreview: function( event ) {
+			return this.setDevicePreview( event.target.dataset.device );
+		},
+
+		setDevicePreview: function ( device ) {
+			// Make the correct button appear active
+			var $footer = this.$el.find( '.wp-full-overlay-footer' );
+			$footer.find( '.active' ).removeClass( 'active' );
+			$footer.find( '.' + device ).addClass( 'active' );
+
+			// Update the iframe with the device class to change the iframe width
+			this.$el.find( '.wp-full-overlay-main iframe' )
+			.removeClass( themes.activeDevicePreview ) // Remove the previous device class
+			.addClass( device );
+
+			// Store our active viewport to reuse if theme changes
+			themes.activeDevicePreview = device;
 
 			return false;
Index: /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-themes/view-templates/theme-preview.php
===================================================================
--- /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-themes/view-templates/theme-preview.php	(revision 12032)
+++ /sites/trunk/wordpress.org/public_html/wp-content/themes/pub/wporg-themes/view-templates/theme-preview.php	(revision 12033)
@@ -40,4 +40,9 @@
 				<span class="collapse-sidebar-arrow"></span>
 			</a>
+			<div class="devices">
+				<button data-device="preview-desktop" class="preview-desktop active"><span class="screen-reader-text"><?php echo _e( 'Enter desktop preview mode', 'wporg-themes' ); ?></span></button>
+				<button data-device="preview-tablet" class="preview-tablet"><span class="screen-reader-text"><?php _e( 'Enter tablet preview mode', 'wporg-themes' ); ?></span></button>
+				<button data-device="preview-mobile" class="preview-mobile"><span class="screen-reader-text"><?php _e( 'Enter mobile preview mode', 'wporg-themes' ); ?></span></button>
+			</div>
 		</div>
 	</div>
